%define modname supercharged-contacts

Summary: Contact management with remote sync for Elastix
Name:    elastix-supercharged-contacts
Version: 1.0.0
Release: 1
License: Proprietary
Group:   Applications/System
Source0: %{modname}_%{version}-%{release}.tgz
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildArch: noarch
Prereq: elastix-framework >= 4.0.0-10
Requires: php-SourceGuardian
Requires: elastix-businessEdition
Requires: php-google-apiclient

%description
Elastix Supercharged Contacts is a contact management application with the
capacity to import and export from other contact sources.
Currently supported synchronization targets:
- MailChimp
- Google Contacts

%prep
%setup -n %{modname}

%install
rm -rf $RPM_BUILD_ROOT

# Files provided by all Elastix modules
mkdir -p    $RPM_BUILD_ROOT/var/www/html/
mv modules/ $RPM_BUILD_ROOT/var/www/html/

mkdir -p $RPM_BUILD_ROOT/var/lib/elastix/elastix-supercharged-contacts/images/


# The following folder should contain all the data that is required by the installer,
# that cannot be handled by RPM.
mkdir -p    $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/
mv setup/   $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/
mv menu.xml $RPM_BUILD_ROOT/usr/share/elastix/module_installer/%{name}-%{version}-%{release}/

%pre
mkdir -p /usr/share/elastix/module_installer/%{name}-%{version}-%{release}/
touch /usr/share/elastix/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
if [ $1 -eq 2 ]; then
    rpm -q --queryformat='%{VERSION}-%{RELEASE}' %{name} > /usr/share/elastix/module_installer/%{name}-%{version}-%{release}/preversion_%{modname}.info
fi

%post
pathModule="/usr/share/elastix/module_installer/%{name}-%{version}-%{release}"

# Run installer script to fix up ACLs and add module to Elastix menus.
elastix-menumerge $pathModule/menu.xml
preversion=`cat $pathModule/preversion_%{modname}.info`
rm $pathModule/preversion_%{modname}.info

if [ $1 -eq 1 ]; then #install
  # The installer database
    elastix-dbprocess "install" "$pathModule/setup/db"
    /sbin/service httpd restart > /dev/null 2>&1
elif [ $1 -eq 2 ]; then #update
    elastix-dbprocess "update"  "$pathModule/setup/db" "$preversion"
    /sbin/service httpd restart > /dev/null 2>&1
fi

# To update smarty (tpl updates)
rm -rf /var/www/html/var/templates_c/*

%clean
rm -rf $RPM_BUILD_ROOT

%preun
if [ $1 -eq 0 ] ; then # Check to tell apart update and uninstall
    elastix-menuremove "supercharged"
fi

%files
%defattr(-, root, root)
%{_localstatedir}/www/html/*
%{_datadir}/elastix/module_installer/*
%{_localstatedir}/lib/elastix/elastix-supercharged-contacts/
%defattr(-, asterisk, asterisk)
%{_localstatedir}/lib/elastix/elastix-supercharged-contacts/images

%changelog
* Mon Aug  1 2016 Alex Villacis Lasso <a_villacis@palosanto.com> 1.0.0-1
- Initial release

