$(document).ready(function() {
    setup_report_contacts();
    setup_form_edit_contact();
    setup_form_membership();
});

function setup_report_contacts()
{
    $('select.contact_email').change(function() {
        $(this).next('a.email_sendto').attr('href', 'mailto:'+$(this).val());
    });
    $('a.call_main_phone').click(function() {
        var phone = $(this).parent('td').children('select.contact_phone').val();
        var id_contact = $(this).parents('tr').first().find('td input[name="id_contact"]').val();
        $.post('index.php', {
            menu:       getCurrentElastixModule(),
            action:     'call2phone',
            rawmode:    'yes',
            id_contact: id_contact,
            phone:      phone
        }, function (response) {
            var arrData = response.message;
            var statusResponse = response.statusResponse;
            var error = response.error;

            if (error != undefined && error != '') alert(error);
        });
    });
    $('a.transfer_main_phone').click(function() {
        var phone = $(this).parent('td').children('select.contact_phone').val();
        var id_contact = $(this).parents('tr').first().find('td input[name="id_contact"]').val();
        $.post('index.php', {
            menu:       getCurrentElastixModule(),
            action:     'transfer_call',
            rawmode:    'yes',
            id_contact: id_contact,
            phone:      phone
        }, function (response) {
            var arrData = response.message;
            var statusResponse = response.statusResponse;
            var error = response.error;

            if (error != undefined && error != '') alert(error);
        });
    });
}

function setup_form_edit_contact()
{
    $('div.form_section_contact').tabs();
    $('div.form_contact_groups').tabs();

    // Ocultar los controles CSV en caso necesario
    $('tr.tr_from_csv').hide();
    $('input[name="contact_data_source"]').change(function() {
        if ($(this).val() == 'address_from_csv') {
            $('tr.tr_from_csv').show();
            $('tr.tr_new_contact').hide();
        } else {
            $('tr.tr_new_contact').show();
            $('tr.tr_from_csv').hide();
        }
    });

    // Quitar el elemento de la lista al hacer clic en la imagen link equis
    $('div.form_contact_groups > div > table > tbody').on('click',
        'tr > td > a.contact_group_delete_item', function() {
        $(this).parents('tr').first().remove();
    });

    // Agregar el elemento a la lista de inserción pendiente
    $('button.button_add_contact_item').button().click(function() {
        var outerdiv = $(this).parent('div');
        var tr_nuevo = outerdiv.parent('div').parent('td').children('table').find('tr').clone();
        var tbody = outerdiv.find('div.form_contact_groups > div:visible > table > tbody');
        var input_main = outerdiv.children('input.txt_item_main');
        var txt_main = input_main.val();
        var input_aux = outerdiv.children('input.txt_item_aux');
        var txt_aux = input_aux.val();
        var attr_name = 'contact_' + outerdiv.data('type') + '[' + outerdiv.find('div.form_contact_groups > div:visible').data('type') + '][]';

        // Validar que sea formato válido
        var rx = new RegExp(input_main.attr('pattern'));
        if (!rx.test(txt_main)) {
            input_main.focus();
            outerdiv.children('span.error_format').show({duration: 0, complete: function() {
                var span = $(this);
                setTimeout(function() { span.fadeOut(); }, 3000);
            }});
            return false;
        }
        if (txt_aux != undefined && txt_aux != '') {
            rx = new RegExp(input_aux.attr('pattern'));
            if (!rx.test(txt_aux)) {
                input_aux.focus();
                outerdiv.children('span.error_format').show({duration: 0, complete: function() {
                    var span = $(this);
                    setTimeout(function() { span.fadeOut(); }, 3000);
                }});
                return false;
            }
        }

        // Validar que no esté repetido
        var txt = txt_main; if (txt_aux != undefined && txt_aux != '') txt += '-' + txt_aux;
        var repetidos = outerdiv.find('input[type="hidden"]').filter(function() {
            return (txt == $(this).val());
        });
        if (repetidos.length > 0) {
            input_main.focus();
            outerdiv.children('span.error_duplicate').show({duration: 0, complete: function() {
                var span = $(this);
                setTimeout(function() { span.fadeOut(); }, 3000);
            }});
            return false;
        }

        tr_nuevo.find('td > input').attr('name', attr_name).val(txt);
        tr_nuevo.find('td > input').after(txt);
        tbody.append(tr_nuevo);
        outerdiv.children('input').val('');

        // Se requiere devolver false para que el click no mande submit del form.
        return false;
    });
}

function setup_form_membership()
{
    // Lista de asignación de directorios de membresía del contacto
    $('ul.dirlist').sortable({
        connectWith: 'ul.dirlist'
    }).disableSelection();
    $('ul.dirlist').on('sortupdate', function(event, ui) {
        //$("input[name=listAgents]").val($(this).sortable('toArray').toString());
        $(this).find('li > input').attr('name', $(this).data('input-name')+'[]');
    });
    $('div#tab-section-contact-membership>div>fieldset>input[name="dirfilter"]').keyup(function(e) {
        var text = $(this).val();
        var liset = $(this).parent('fieldset').children('ul.dirlist').children('li');
        if (text == '') {
            // Si se pone texto en blanco, se muestran todos los agentes
            liset.show();
        } else {
            // Filtrar usando :contains
            liset.hide();
            liset.filter(':contains('+text+')').show();
        }
    });
}
