$(document).ready(function() {
    $('input#enabled, input[name=chkoldenabled]').change(function() {
        if ($('input#enabled').val() == 'off') {
            $('tr.only-if-sync-enabled').hide();
        } else {
            $('tr.only-if-sync-enabled').show();
        }
        $('tr.only-if-sync-enabled > td > select#id').change();
    });
    $('tr.only-if-sync-enabled > td > select#id').change(function() {
        $('tr.only-if-new-list').hide();
        if ($(this).is(':visible') && $(this).val() == '_new') {
            $('tr.only-if-new-list').show();
        }
    });
    $('input[name=chkoldenabled]').change();
    $('tr.only-if-sync-enabled > td > select#id').change();

    // Botón para cargar la lista de contactos
    $('button#google_load_groups').click(do_google_load_groups);

    $('select#id').change(function() {
        $('input[name=id_label]').val($(this).children('option:selected').text());
    });

    $('tr.sync_report, tr.sync_wait').hide();

    $('button#google_import').click(do_google_import);
    $('button#google_export').click(do_google_export);
});

function do_google_load_groups()
{
    $.get('index.php', {
        menu:               getCurrentElastixModule(),
        action:             'config_sync',
        rawmode:            'yes',
        id_dir:             $('input[type="hidden"][name="id_dir"]').val(),
        synctarget:         $('select[name="synctarget"]').val(),
        synctarget_action:  'load_groups'
    }, function (response) {
        var arrData = response.message;
        var statusResponse = response.statusResponse;
        var error = response.error;

        if (statusResponse == 'NOAUTH') {
            // No se ha realizado la autenticación de Google

            window.location = arrData;
            return;
        } else if (statusResponse == 'ERROR') {
            alert(error);
            return;
        }

        var gsel = $('select#id');
        var id = gsel.val();

        // Quitar todos los elementos del select excepto los de value '' y '_new'
        var group_null = gsel.children('option[value=""]');
        var group_new = gsel.children('option[value="_new"]');
        gsel.empty().append(group_null).append(group_new);

        // Agregar nuevos elementos para representar los grupos
        for (var i = 0; i < arrData.length; i++) {
            gsel.append($('<option />').val(arrData[i].value).text(arrData[i].label));
        }

        // Restaurar selección anterior, si había
        gsel.val(id);
        gsel.change();
    });

    return false;
}

function do_google_create_group(name)
{
    // NOTA: chkoldenabled es un nombre generado por paloSantoFramework
    if (!$('input[name=chkoldenabled]').is(':checked')) {
        // Indicar que se habilita la sincronización Google
        $('input[name=chkoldenabled]').click();
    }
    $('select#id').val('_new').change(); // Nueva lista
    $('input[name="name"]').val(name);
    $('input[name="save"]').click();    // Debería iniciar un submit
}

function do_google_import()
{
    $('tr.sync_report').hide();
    $('tr.sync_wait').show();
    $.post('index.php', {
        menu:               getCurrentElastixModule(),
        action:             'run_sync',
        rawmode:            'yes',
        id_dir:             $('input[type="hidden"][name="id_dir"]').val(),
        synctarget:         $('select[name="synctarget"]').val(),
        synctarget_action:  'import'
    }, function (response) {
        var arrData = response.message;
        var statusResponse = response.statusResponse;
        var error = response.error;

        $('tr.sync_wait').hide();
        if (statusResponse == 'NOAUTH') {
            // No se ha realizado la autenticación de Google

            window.location = arrData;
            return;
        } else if (statusResponse == 'ERROR') {
            alert(error);
            return;
        }
        $('td#sync_result_total').text(arrData.total);
        $('td#sync_result_created').text(arrData.created);
        $('td#sync_result_updated').text(arrData.updated);
        $('tr.sync_report').show();
    });

    return false;
}

function do_google_export()
{
    $('tr.sync_report').hide();
    $('tr.sync_wait').show();
    $.post('index.php', {
        menu:               getCurrentElastixModule(),
        action:             'run_sync',
        rawmode:            'yes',
        id_dir:             $('input[type="hidden"][name="id_dir"]').val(),
        synctarget:         $('select[name="synctarget"]').val(),
        synctarget_action:  'export'
    }, function (response) {
        var arrData = response.message;
        var statusResponse = response.statusResponse;
        var error = response.error;

        $('tr.sync_wait').hide();
        if (statusResponse == 'NOAUTH') {
            // No se ha realizado la autenticación de Google

            window.location = arrData;
            return;
        } else if (statusResponse == 'ERROR') {
            alert(error);
            return;
        }
        $('td#sync_result_total').text(arrData.total);
        $('td#sync_result_created').text(arrData.created);
        $('td#sync_result_updated').text(arrData.updated);
        $('tr.sync_report').show();
    });

    return false;
}
